<?php

namespace Wincher\Controller;

class DashboardController extends RestController
{
    public function getSearchEngines(\WP_REST_Request $request)
    {
        return $this->handleApiResponse($this->wincherClient->getSearchEngines());
    }

    public function getDashboardData(\WP_REST_Request $request)
    {
        return $this->handleApiResponse(
            $this->wincherClient->getDashboardData(
                $request->get_param('id'),
                new \DateTime($request->get_param('start_date')),
                new \DateTime($request->get_param('end_date'))
            )
        );
    }

    public function getRankingHistory(\WP_REST_Request $request)
    {
        return $this->handleApiResponse(
            $this->wincherClient->getRankingHistory(
                $request->get_param('keyword_ids')
            )
        );
    }

    public function createKeyword(\WP_REST_Request $request)
    {
        $params = $request->get_json_params();

        return $this->handleApiResponse(
            $this->wincherClient->createKeyword($params['domain_id'], $params['keyword'])
        );
    }

    public function deleteKeywords(\WP_REST_Request $request)
    {
        $params = $request->get_json_params();

        return $this->handleApiResponse(
            $this->wincherClient->deleteKeywords($params['domain_id'], $params['keyword_ids'])
        );
    }

    private function handleApiResponse($resp)
    {
        return new \WP_REST_Response($resp['data'], $resp['status']);
    }
}
